/* Includes ----------------------------------------------------------------- */
#include "task\user_task.h"
#include "bsp\led.h"
#include "bsp\buzzer.h"
#include "device\can.h"

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */

void Task_Monitor(void *argument) {
    (void)argument; // 消除未使用参数的警告
    const uint32_t delay_tick = osKernelGetTickFreq() / TASK_FREQ_MONITOR; // 1000Hz
    uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
    BSP_LED_Set(BSP_LED_RED, BSP_LED_ON, 1); 
    BSP_LED_Set(BSP_LED_BLUE, BSP_LED_ON, 1); 
    BSP_Buzzer_Set(0.5, 0.3f); 
    BSP_Buzzer_Start();
    HAL_Delay(300);
    BSP_Buzzer_Set(0.5, 0.4f); 
    HAL_Delay(300);
    BSP_Buzzer_Set(0.5, 0.5f);
    HAL_Delay(300);
    BSP_Buzzer_Stop();

    while (1) {
        tick += delay_tick; /* 计算下一个唤醒时刻 */

        // TODO: 监控任务的具体实现
        BSP_LED_Set(BSP_LED_GREEN, BSP_LED_TAGGLE, 1);
        osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
    }
}